]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- in infodir compress only *.info*, omitting images
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 # Build system path macros.
12 #
13 %__autoconf             autoconf %{?debug:-Wall}
14 %__automake             automake -a -c -f --foreign
15 %__autopoint            autopoint --force
16
17 %__gettextize { \
18 if ! gettextize --version | grep -q '0\.10\.' ; then \
19         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
20                 gettextize --copy --force --no-changelog; \
21         else \
22                 gettextize --copy --force --no-changelog --intl; \
23         fi; \
24         if [ ! -f po/Makevars ]; then \
25                 cp -f po/Makevars{.template,}; \
26         fi; \
27 else \
28         gettextize --copy --force; \
29 fi; \
30 }
31
32 %__glib_gettextize      glib-gettextize --copy --force
33 %__gnome_doc_common     gnome-doc-common --copy
34 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
35 %__gtkdocize            gtkdocize --copy
36 %__intltoolize          intltoolize --copy --force
37 %__libtoolize           libtoolize --copy --force
38
39 #       The number of cvs changelog entries kept when building package.
40 %_buildchangelogtruncate 20
41
42 %dependencytracking     %{nil}
43
44 #       Relations between package names that cause dependency loops
45 #       with legacy packages that cannot be fixed. Relations are
46 #       specified as
47 #               p>q
48 #       where package p has a Requires: on something that package q Provides:
49 #
50 # XXX   Note: that there cannot be any whitespace within the string "p>q",
51 #       and that both p and q are package names (i.e. no version/release).
52 %_dependency_whiteout   %{nil}
53
54
55 #-----------------------------------------------------------------
56 #
57 # (re)definition of %{rpm*flags} with %filterout_* support
58 # BuildRequires:        awk
59 # BuildRequires:        rpmbuild(macros) >= 1.315
60 #
61 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
62 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
63 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
64 # %rpmldflags   = %optldflags - %filterout_ld
65 #
66 # Regular expressions are supported, but to avoid some character be treated
67 # as regular expression it must be escaped twice.
68
69 %filter_out                                             \
70         for (i = 1; i in I; i++) {      A=0;    \
71                 for (f in F) {                          \
72                         if (I[i] ~ "^" F[f] "$") A=1;   \
73                 };                                                      \
74                 if (!A) printf(I[i] FS);        \
75         }
76
77 %rpmcflags %(awk 'BEGIN {
78         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
79         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
80         %{filter_out}
81 }')
82
83 %rpmcxxflags %(awk 'BEGIN {
84         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
85         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
86         %{filter_out}
87 }')
88
89 %rpmldflags %(awk 'BEGIN {
90         split("%{?optldflags}",I);
91         split("%{?filterout_ld}",F)
92         %{filter_out}
93 }')
94
95 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
96 # but, don't use it, better use gcc as linker
97 %ld_rpmldflags %(awk 'BEGIN {
98         split("%{rpmldflags}",F);
99         for (f in F) {
100                 s = F[f];
101                 if (s ~ /^-Wl,/) {
102                         s = substr(s,5);
103                         gsub(/,/," ",s);
104                 };
105                 printf(s FS);
106         };
107 }')
108
109 #-----------------------------------------------------------------
110 %configure2_13 { \
111  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
112  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
113  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
114  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
115  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
116  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
117  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
118  %{?__cc:CC="%{__cc}" ; export CC ; } \
119  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
120  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
121         --host=%{_target_platform} \
122         --prefix=%{_prefix} \
123         --exec-prefix=%{_exec_prefix} \
124         --bindir=%{_bindir} \
125         --sbindir=%{_sbindir} \
126         --sysconfdir=%{_sysconfdir} \
127         --datadir=%{_datadir} \
128         --includedir=%{_includedir} \
129         --libdir=%{_libdir} \
130         --libexecdir=%{_libexecdir} \
131         --localstatedir=%{_localstatedir} \
132         --sharedstatedir=%{_sharedstatedir} \
133         --mandir=%{_mandir} \
134         --infodir=%{_infodir} \
135         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
136         %{dependencytracking} \
137 }
138
139 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
140 %__cmake        /usr/bin/cmake
141 %cmake { \
142 CC="%{__cc}" \
143 CXX="%{__cxx}" \
144 CFLAGS="%{rpmcflags}" \
145 CXXFLAGS="%{rpmcxxflags}" \
146 %{__cmake} \
147 }
148
149 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
150 # TODO: find way to pass CC/CXX and CC/CXXFLAGS
151 %__scons        /usr/bin/scons
152 %scons { \
153 %{__scons} \
154 }
155
156 # waf. see waf.spec
157 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
158 %__waf  /usr/bin/waf
159 %waf { \
160 CC="%{__cc}" \
161 CXX="%{__cxx}" \
162 CPP="%{__cpp}" \
163 CFLAGS="%{rpmcflags}" \
164 CXXFLAGS="%{rpmcxxflags}" \
165 %{__waf} \
166 }
167
168 #----------------------------------------------------------------
169 %global configure_cache 0
170 %configure_cache_file   %{buildroot}.configure.cache
171
172 %configure {./configure \
173         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
174         CFLAGS="${CFLAGS:-%rpmcflags}" \
175         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
176         FFLAGS="${FFLAGS:-%rpmcflags}" \
177         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
178         CPPFLAGS="${CPPFLAGS:-}" \
179         %{?__cc:CC="%{__cc}"} \
180         %{?__cxx:CXX="%{__cxx}"} \
181         --host=%{_target_platform} \
182         --build=%{_target_platform} \
183         --prefix=%{_prefix} \
184         --exec-prefix=%{_exec_prefix} \
185         --bindir=%{_bindir} \
186         --sbindir=%{_sbindir} \
187         --sysconfdir=%{_sysconfdir} \
188         --datadir=%{_datadir} \
189         --includedir=%{_includedir} \
190         --libdir=%{_libdir} \
191         --libexecdir=%{_libexecdir} \
192         --localstatedir=%{_localstatedir} \
193         --sharedstatedir=%{_sharedstatedir} \
194         --mandir=%{_mandir} \
195         --infodir=%{_infodir} \
196         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
197         %{dependencytracking} \
198         %{?configure_cache:--cache-file=%{configure_cache_file:-%{buildroot}.configure.cache}} \
199 }
200
201 # ------------------------------------------------------------------------
202 # Overloading of some basic macros
203 %prep \
204 %%prep\
205 export LC_ALL=C\
206 export LANG=C\
207 unset LINGUAS ||:\
208 unset LANGUAGE ||:\
209 unset LC_MESSAGES ||:\
210 unset DISPLAY ||:\
211 %{nil}
212
213 %build %%build\
214 export LC_ALL=C\
215 export LANG=C\
216 unset LINGUAS ||:\
217 unset LANGUAGE ||:\
218 unset LC_MESSAGES ||:\
219 unset DISPLAY ||:\
220 %{nil}
221
222 %install \
223 %if 0%{?_enable_debug_packages}\
224 %{?buildsubdir:%{debug_package}}\
225 %endif\
226 %%install\
227 export LC_ALL=C\
228 export LANG=C\
229 unset LINGUAS ||:\
230 unset LANGUAGE ||:\
231 unset LC_MESSAGES ||:\
232 unset DISPLAY ||:\
233 %{nil}
234
235 # Location of autoconf macros
236 %_aclocaldir    %(aclocal --print-ac-dir)
237
238 # Location of omf files
239 %_omf_dest_dir  %(scrollkeeper-config --omfdir)
240
241 # Location of pkgconfig files
242 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
243
244 # Location of desktop files
245 %_desktopdir    /usr/share/applications
246 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
247
248 # Location of pixmaps for applnk/desktop files
249 %_pixmapsdir    /usr/share/pixmaps
250
251 # Location of themable icons for applnk/desktop files
252 %_iconsdir      /usr/share/icons
253
254 # Location of fonts directories
255 %_fontsdir      /usr/share/fonts
256
257 # Location of Gtk and associated libraries documentation
258 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
259
260 # Location of KDE documentation
261 %_kdedocdir     %{_defaultdocdir}/kde/HTML
262
263 # unsermake script
264 %__unsermake /usr/share/unsermake/unsermake
265
266 # Current date
267 %date           %(LC_ALL="C" date +"%a %b %d %Y")
268
269 # tmp directory
270 %tmpdir         %(echo "${TMPDIR:-/tmp}")
271
272 # Example files, programs, scripts...
273 %_examplesdir   /usr/src/examples
274
275 # Alternative kernel type/version
276 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
277
278 # The directory holding Linux kernel sources
279 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
280
281 # If non-empty "debug" macro defined, add "dbg" suffix to release number
282 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
283
284 # Requires name = version-release
285 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
286
287 %releq_kernel()         %((LC_ALL="C" rpm -qf --qf '%%{name} = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
288 %requires_releq_kernel(s:)      Requires%{-s:(%{-s*})}: %releq_kernel
289
290 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}\\n' | sed -e 's/ (none):/ /' -e 's/ 0:/ /' | grep -v "is not")
291 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
292
293 %apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
294
295 # kernel version-release handling
296 %__kernel_ver   %( VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
297 %__kernel_rel   %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
298 %__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
299 %_kernel_ver    %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
300 %_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
301
302 # sgml macros
303 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
304 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
305 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
306 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
307 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
308 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
309 %docbook_sgmlcat_fix() { for l in \
310 '' \
311 '  -- default decl --' \
312 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
313 '  -- hacks for opensp --' \
314 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
315 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
316 '' \
317 ; do echo $l; done >> %1 \
318 }
319
320 # vim - "
321
322 # minimum file size needed for compressed documents.
323 # just smaller files than this get larger when compressed.
324 # some stats:
325 # - 0 byte file compressed was 25 bytes .gz
326 # - 39 byte file was compressed as 57
327 # - with test/test.spec@man 158 byte file was compressed also 158
328 %_min_compress_bytes    159
329
330 #-----------------------------------------------------------------
331 # find and gzip all files in %{_mandir} and %{infodir}
332 #
333 # Requires: xargs, find
334 #
335 #%no_install_post_compress_docs 1
336 %__spec_install_post_compress_docs { \
337 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
338         for i in /usr/share/man /usr/X11R6/man; do \
339                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
340                         echo "Compress man pages: $i"; \
341                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
342                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
343                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
344                 fi; \
345         done; \
346         if [ -d "$RPM_BUILD_ROOT$i" ]; then \
347                 echo "Compress info pages: $i"; \
348                 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
349                 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
350                 find "$RPM_BUILD_ROOT$i" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
351         fi; \
352 }; __spec_install_post_compress_docs } }
353
354 #-----------------------------------------------------------------
355 # Strip executable binaries and shared object files
356 #
357 # Requires: find, awk, strip, cut, xargs
358 #
359 #%no_install_post_strip 1
360 %__spec_install_post_strip {%{!?debug: \
361 %{!?no_install_post_strip:__spec_install_post_strip() { \
362 if [ -d "$RPM_BUILD_ROOT" ]; then \
363         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
364                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
365                 printf "Stripping %d kernel modules..." $(echo "$modulelist" | wc -l); \
366                 echo "$modulelist" | xargs -l512 chmod u+w; \
367                 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
368                 echo "DONE"; \
369         fi; \
370         filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"}`; \
371         # vim - " \
372         if [ -z "$filelist" ]; then \
373                 return; \
374         fi; \
375         filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
376         elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
377         elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
378         archiveslist=`echo "$filetypes" | awk -F '/current ar archive/ {print $1}'`; \
379         if [ -n "$elfexelist" ]; then \
380                 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
381                 chmod u+w $elfexelist; \
382                 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
383                 echo "DONE"; \
384         fi; \
385         if [ -n "$elfsharedlist" ]; then \
386                 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
387                 chmod u+w $elfsharedlist; \
388                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
389                 echo "DONE"; \
390         fi; \
391         if [ -n "$archiveslist" ]; then \
392                 printf "Stripping %d ar archives..." $(echo "$elfsharedlist" | wc -l); \
393                 chmod u+w $archiveslist; \
394                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
395                 echo "DONE"; \
396         fi; \
397 fi; }; __spec_install_post_strip } } }
398
399 #-----------------------------------------------------------------
400 # remove all RPATH from executable binaries and shared object files
401 #
402 # Requires: find, awk, cut, xargs, chrpath, uname
403 #
404 #%no_install_post_chrpath       1
405 %__spec_install_post_chrpath {%{!?debug: \
406 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
407 if [ -d "$RPM_BUILD_ROOT" ]; then \
408         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*"  %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
409         if [ -n "$files" ]; then \
410                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
411         fi
412         #"
413         if [ -n "$objs" ]; then \
414                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
415                 echo "$objs" | \
416                 while read file; do \
417                         rpath= ; \
418                         chmod u+w "$file"; \
419                         for dir in `chrpath -l "$file" | \
420                                         awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
421                                         case $dir in \
422                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
423                                                 echo "remove-rpath: $dir in $file"; \
424                                                 ;; \
425                                         * ) \
426                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
427                                                 else rpath="$rpath:$dir" ; fi ; \
428                                                 ;; \
429                                         esac ; \
430                         done ; \
431                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
432                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
433                 done; \
434         fi; \
435 fi; }; __spec_install_post_chrpath } } }
436
437 #-----------------------------------------------------------------
438 # Find and gzip all kernel modules
439 #
440 # Requires: find
441 #
442 #%no_install_post_compress_modules      1
443 %__spec_install_post_compress_modules { \
444 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
445         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
446                 echo "Compress kernel modules"; \
447                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
448                 echo "$q" | xargs -r %{__gzip} -9nf; \
449                 printf "%d modules compressed\n" $(echo "$q" | wc -l); \
450                 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
451                 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
452         fi; \
453 }; __spec_install_post_compress_modules } }
454
455 # Remove common Perl files we don't package
456 %__spec_install_post_perl_clean {\
457 %{!?no_install_post_perl_clean: \
458 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
459 } }
460
461 #-----------------------------------------------------------------
462 # Update GConf2 schemas
463 #
464 # Requires: GConf2
465 #
466 %gconf_schema_install() \
467         umask 022; \
468         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
469         %{nil}
470
471 %gconf_schema_uninstall() \
472 if [ $1 = 0 ]; then \
473         umask 022; \
474         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
475 fi \
476 %{nil}
477
478 #-----------------------------------------------------------------
479 # Update desktop MIME database
480 # requires: desktop-file-utils
481 #
482 %update_desktop_database_post() {{ \
483         umask 022; \
484         /usr/bin/update-desktop-database -q; \
485 }}
486
487 %update_desktop_database_postun() {{ \
488 if [ $1 = 0 ]; then \
489         umask 022; \
490         /usr/bin/update-desktop-database -q; \
491 fi \
492 }}
493
494 #-----------------------------------------------------------------
495 # Update shared MIME info database
496 # requires: shared-mime-info
497 #
498 %update_mime_database() {{ \
499         umask 022; \
500         /usr/bin/update-mime-database %{_datadir}/mime; \
501 }}
502
503 #-----------------------------------------------------------------
504 # Update icon cache
505 # requires: gtk+
506 #
507 %update_icon_cache() {{ \
508         umask 022; \
509         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
510 }}
511
512 #-----------------------------------------------------------------
513 # Update scrollkeeper database
514 # requires: scrollkeeper
515 #
516 %scrollkeeper_update_post() \
517         /usr/bin/scrollkeeper-update -q; \
518         %{nil}
519
520 %scrollkeeper_update_postun() \
521 if [ $1 = 0 ]; then \
522         /usr/bin/scrollkeeper-update -q; \
523 fi \
524 %{nil}
525
526 #-----------------------------------------------------------------
527 # post %install sequence:
528 # - autodeps exceptions
529 # - compress all man and info pages,
530 # - strip all ELF executables and ELF shared objects if not %debug.
531 # - compress kernel modules if any
532
533 ###################################################################
534 # Requires/Provides automation
535 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
536 #
537 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
538 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
539 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
540 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
541 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
542 #%_noautocompressdoc    %{nil}
543 #
544 %_missing_doc_files_terminate_build     1%{nil}
545 %_unpackaged_files_terminate_build      %{nil}
546 # (X)emacs support
547 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
548 %_emacs_lispdir %(emacs %___emacs_lispdir_helper)
549 %_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
550
551 %__php_provides %{nil}
552 %__php_requires %{nil}
553 %__perl_provides %{nil}
554 %__perl_requires %{nil}
555 %__mono_provides %{nil}
556 %__mono_requires %{nil}
557
558 # Perl specific macro definitions.
559 %perl_privlib           %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
560 %perl_archlib           %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
561 %perl_vendorlib         %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
562 %perl_vendorarch        %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
563 %perl_sitelib           %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
564 %perl_sitearch          %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
565
566 # Ruby
567 %ruby_archdir           %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
568 %ruby_ridir                     %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
569 %ruby_rubylibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
570 %ruby_sitearchdir       %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
571 %ruby_sitelibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
572 %ruby_version           %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
573 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
574 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
575
576 %php_pear_dir           /usr/share/pear
577 %php_extensiondir       %(php-config --extension-dir 2>/dev/null || echo ERROR)
578 %php_sysconfdir         %(php-config --sysconfdir 2>/dev/null || echo ERROR)
579
580 # directory where php includes are installed on system.
581 %__php_includedir               /usr/include/php
582 # extract php/zend api versions
583 %php_major_version              %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{__php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
584 %php_api_version                %(awk '/#define PHP_API_VERSION/{print $3}' %{__php_includedir}/main/php.h 2>/dev/null || echo ERROR)
585 %php_pdo_api_version    %(awk '/#define PDO_DRIVER_API/{print $3}' %{__php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
586 %php_debug                              %(awk '/#define ZEND_DEBUG/{print $3}' %{__php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
587 %zend_module_api                %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{__php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
588 %zend_extension_api             %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{__php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
589 %zend_zts                               %(Z=$(grep -sc '^#define ZTS 1' %{__php_includedir}/main/php_config.h); echo ${Z:-ERROR})
590
591 # helper macro
592 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
593
594 # macros for public use
595 # for php extensions (php-pecl)
596 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
597 %{__php_api_requires zend_module_api} \
598 %{__php_api_requires -v %php_major_version debug php_debug} \
599 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
600
601 # for zend extensions
602 %requires_zend_extension %{__php_api_requires zend_module_api} \
603 %{__php_api_requires zend_extension_api} \
604 %{__php_api_requires -v %php_major_version debug php_debug} \
605 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
606
607 # for php pdo modules (php-pecl-PDO_*)
608 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
609
610 # for using PHP post scripts. for PHP >= 5.0
611 %php_webserver_restart \
612 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
613 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
614 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
615         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
616         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
617                 %service -q php-fcgi restart \
618         fi \
619 fi \
620 %{nil}
621
622 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
623 %php4_webserver_restart \
624 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
625 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
626 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
627         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
628         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
629                 %service -q php-fcgi restart \
630         fi \
631 fi \
632 %{nil}
633
634 # Python specific macro definitions.
635 # python main version
636 %py_ver                 %(python -c "import sys; print sys.version[:3]")
637
638 # directories
639 %py_prefix              %(python -c "import sys; print sys.prefix")
640 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
641 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
642 %py_incdir              /usr/include/python%{py_ver}
643 %py_sitedir             %{py_libdir}/site-packages
644 %py_sitescriptdir %{py_scriptdir}/site-packages
645 %py_dyndir              %{py_libdir}/lib-dynload
646
647 # pure python modules compilation
648 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
649
650 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
651
652 # Software written in Python language require Python with main version
653 %pyrequires_eq() Requires:      %1
654
655 # Hardlink binary identical .pyc and .pyo files
656 # (idea by glen <at> pld-linux <dot> org)
657 %__spec_install_post_py_hardlink {\
658 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
659 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
660         b="$(echo $a|sed -e 's/.pyc$/.pyo/')"; \
661         if cmp -s "$a" "$b"; then \
662                 ln -f "$a" "$b"; \
663         fi; \
664 done \
665 }; __spec_install_post_py_hardlink } }
666
667 # remove python sources, so that check-files won't complain
668 # (idea by glen <at> pld-linux <dot> org)
669 %py_postclean() \
670 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
671  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
672 done \
673 %{nil}
674
675 # depmod macro
676 %depmod() { \
677 umask 022; \
678 if [ -e /boot/System.map-%1 ]; then \
679         /sbin/depmod -a -F /boot/System.map-%1 %1; \
680 else \
681         if [ -e /boot/System.map ]; then \
682                 /sbin/depmod -a -F /boot/System.map %1; \
683         else \
684                 /sbin/depmod -a %1; \
685         fi \
686 fi; \
687 }
688
689 # XMMS specific macros
690 %xmms_prefix                    %(xmms-config --prefix 2>/dev/null)
691 %xmms_exec_prefix               %(xmms-config --exec-prefix 2>/dev/null)
692 %xmms_version                   %(xmms-config --version 2>/dev/null)
693 %xmms_datadir                   %(xmms-config --data-dir 2>/dev/null)
694 %xmms_plugindir                 %(xmms-config --plugin-dir 2>/dev/null)
695 %xmms_visualization_plugindir   %(xmms-config --visualization-plugin-dir 2>/dev/null)
696 %xmms_input_plugindir           %(xmms-config --input-plugin-dir 2>/dev/null)
697 %xmms_output_plugindir          %(xmms-config --output-plugin-dir 2>/dev/null)
698 %xmms_effect_plugindir          %(xmms-config --effect-plugin-dir 2>/dev/null)
699 %xmms_general_plugindir         %(xmms-config --general-plugin-dir 2>/dev/null)
700
701 %_target_base_arch      %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
702
703 # user/group checking macros
704 #
705 # Usage:
706 #       %userremove myuser
707 #
708 %userremove     /usr/lib/rpm/user_group.sh user del
709 %groupremove    /usr/lib/rpm/user_group.sh group del
710 #
711 # Usage:
712 #       if %usertestrm myuser; then
713 #               /usr/sbin/userdel -r myuser
714 # Note:
715 #       use these macros only if you need to call userdel/groupdel with
716 #       a non-standard option or take an extra action; otherwise use the
717 #       %userremove/%groupremove macros
718 #
719 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
720 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
721 # user group membership management macros
722 #
723 # Usage:
724 #       %addusertogroup myuser agroup
725 #
726 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
727
728 # banner support (useful in {pre,post}{,un} and triggers)
729 #
730 # Usage:
731 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
732 # the banner text, the banner text
733 # the banner text, and following line
734 #EOF
735 # You can use any form of here-document, <<'EOF' <<-EOT will do.
736 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
737 #
738 # -a   - append to the banner
739 # -e   - send to stderr instead of stdout
740 # -n   - no show banner (overrides -t)
741 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
742 %banner(aent:)  \
743 RPM_SCRIPTVERBOSITY=5 \
744 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
745 if [ -x /usr/bin/banner.sh ]; then \
746         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
747 else \
748         CMD="cat%{-e: >&2}" \
749 fi \
750 eval $CMD %2%{?3: %3} \
751 %nil
752
753 # useradd/groupadd macros
754 # Author: Elan Ruusamäe <glen@pld-linux.org>
755 #
756 # Usage:
757 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
758 #   [-g initial_group] [-G group[,...]] login
759 #
760 #  -u uid. REQUIRED
761 #  -g gid/group. REQUIRED
762 #  -s defaults to /bin/false
763 #  -d defaults to /usr/share/empty
764 #  -c No default
765 #  -r is accepted but ignored (it's always set)
766 #  -k skeleton dir. defaults to /usr/share/empty
767 # rpm specific flags
768 #  -P package name. defaults to %{name}
769 #
770 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
771 %{!-u:%{error:useradd: Required argument -u missing}} \
772 %{!-g:%{error:useradd: Required argument -g missing}} \
773 %{!?1:%{error:useradd: Required parameter login missing}} \
774 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
775         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
776                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
777                 exit 1 \
778         fi \
779 else \
780         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
781         /usr/sbin/useradd \\\
782                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
783                 -u %{-u*} \\\
784                 -r \\\
785                 -d %{-d*}%{!-d:/usr/share/empty} \\\
786                 -s %{-s*}%{!-s:/bin/false} \\\
787                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
788                 -g %{-g*} \\\
789                 %{-M} \\\
790                 %{-G:-G %{-G*}} \\\
791                 %{expand:%{%{#}}} 1>&2 || exit $? \
792         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
793 fi;
794
795 # Usage:
796 #   %groupadd [-P package] [-g gid] group
797 #
798 # -g gid. REQUIRED
799 #
800 # Sample:
801 #   %groupadd -P %{name}-base -g %{gid} %{name}
802
803 %groupadd(g:P:rfo)      \
804 %{!-g:%{error:groupadd: Required argument -g missing}} \
805 %{!?1:%{error:groupadd: Required parameter group missing}} \
806 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
807         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
808                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
809                 exit 1 \
810         fi \
811 else \
812         echo "Adding group %{1} GID=%{-g*}." \
813         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
814         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
815 fi;
816
817 # apache_config_{install/uninstall} macros *DEPRECATED*
818 # Author: Elan Ruusamäe <glen@pld-linux.org>
819 #
820 # You should use webapp macros instead. these are here until single piece of
821 # them is gone from specs ;)
822 #
823 # The config is installed/removed inside trigger, this means that you can any
824 # time install apache1 or apache package and the configuration file is updated.
825 # if you don't need the config for various reason for specific apache, just
826 # remove the symlink from apache config directory. the trigger will not put the
827 # config again to that version of apache. In other words the config is linked
828 # to apache config directory on first install of PACKAGE or apache.
829 #
830 # should be called in trigger body:
831 #  %triggerin -- apache1 >= 1.3.33-2
832 #  %apache_config_install -v 1
833 #
834 # Add package's apache config to apache config.
835 #
836 # Usage:
837 #   %apache_config_install -v {1|2} -c %{_sysconfdir}/apache-%{name}.conf -n 99
838 #
839 #  -v REQUIRED: specify apache version. can be 1 or 2.
840 #  -c OPTIONAL: specify full path to PACKAGE's config. Defaults to %{_sysconfdir}/apache-%{name}.conf.
841 #  -n OPTIONAL: specify config "slot". defaults to 99
842 #  -f OPTIONAL: force symlink creation regardless if package was upraded. useful in triggers
843 #
844 # Internal macros. don't use ;).
845 # expands apache config dir by apache version at build time.
846 %__apache_confdir() %(if [ %{1} = 1 ]; then echo /etc/apache/conf.d; elif [ %{1} = 2 ]; then echo /etc/httpd/httpd.conf; else echo >&2 Unknown apache version specified; fi)
847 # expands apache service name by apache version at build time.
848 %__apache_svcname() %(if [ %{1} = 1 ]; then echo apache; elif [ %{1} = 2 ]; then echo httpd; else echo >&2 Unknown apache version specified; fi)
849
850 %apache_config_install(fv:c:n:) \
851 %{!-v:%{error:apache_config_install: Required argument -v missing}} \
852 %{?debug:set -x; echo "apache_config_install:%{-v*} %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
853 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ]) && [ -d %{__apache_confdir %{-v*}} ]; then\
854         ln -sf %{-c*}%{!-c:%{_sysconfdir}/apache-%{name}.conf} %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf\
855 fi\
856 # reload apache if the config symlink is there\
857 if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then\
858         # additionally don't reload if target package (the webserver) is upgraded, as webserver is restarted anyway in %post \
859         if [ "$2" != "2" ] && [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then\
860                 /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2\
861         fi\
862 fi\
863 %{nil}
864
865 # Remove package's apache config from apache config.
866 #
867 # Usage:
868 #   %apache_config_uninstall -v {1|2} -n 99
869 #
870 #  -v REQUIRED: specify apache version. can be 1 or 2.
871 #  -n OPTIONAL: specify config "slot". defaults to 99
872 %apache_config_uninstall(v:n:) \
873 %{!-v:%{error:apache_config_uninstall: Required argument -v missing}} \
874 %{?debug:set -x; echo "apache_config_uninstall:%{-v*} %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
875 # remove link if either of the packages are gone \
876 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
877         if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then \
878                 rm -f %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf \
879                 if [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then \
880                         /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2 \
881                 fi \
882         fi \
883 fi \
884 %{nil}
885
886 # webapp macros
887 # Author: Elan Ruusamäe <glen@pld-linux.org>
888 #
889 # The config is installed/removed inside trigger, this means that you can any
890 # time install apache1/apache/lighttpd package and the configuration file is
891 # updated. if you don't need the config for various reason for specific
892 # webserver, just remove the symlink from config directory using webapp
893 # program. the trigger will not recreate the symlink on upgrades. In other
894 # words the config is linked to webserver config directory on first install of
895 # PACKAGE or WEBSERVER.
896 #
897 # Add package's webserver config to webserver webapps dir.
898 # Usage:
899 #   %webapp_register WEBSERVER WEBAPP
900 #
901 %webapp_register() \
902 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
903 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
904         /usr/sbin/webapp register %1 %2\
905 fi\
906 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
907 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
908         %{expand:%service -q %%1 reload}\
909 fi\
910 %{nil}
911
912 # Remove package's config from webserver webapps dir.
913 # Usage:
914 #   %webapp_register [-f] WEBSERVER WEBAPP
915 %webapp_unregister(f) \
916 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
917 # remove link if either of the packages are gone \
918 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
919         /usr/sbin/webapp unregister %1 %2\
920         %{expand:%service -q %%1 reload}\
921 fi \
922 %{nil}
923
924 # see browser-plugins.spec / template-browser-plugin.spec
925 # Author: Elan Ruusamäe <glen@pld-linux.org>
926 %nsplugin_install(d:f) { \
927 # create link if it's first install of either of the packages \
928 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ] && [ -d %{-d*} ]); then \
929 ( \
930 %( \
931         for file in %{*}; do \
932                 echo echo Installing $file to %{-d*}; \
933                 echo "ln -sf %{_libdir}/browser-plugins/$file %{-d*};"; \
934         done ) \
935 ) | ( %banner -t 5 -e %{name}-in ); fi; \
936 }
937
938 %nsplugin_uninstall(d:) { \
939 # remove link if either of the packages are gone \
940 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
941 ( \
942 %( \
943         for file in %{*}; do \
944                 echo echo Removing $file from %{-d*}; \
945                 echo "rm -f %{-d*}/$file;"; \
946         done ) \
947 ) | ( %banner -t 5 -e %{name}-un ); fi; \
948 }
949
950 # service macro.
951 # Author: Elan Ruusamäe <glen@pld-linux.org>
952 #
953 # calls usual service restart on package %post, but skips the restart if
954 # administrator has disabled automatic service restarts in either global
955 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
956 #
957 # Usage:
958 #   %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
959 #
960 #  -q be silent when service isn't started (for scriplets restaring other package's services)
961 #
962 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
963
964
965 # Java macros. based on jpackage macros.java
966 #
967 # Root directory where all Java VMs/SDK/JREs are installed.
968 %_jvmdir                %{_libdir}/jvm
969
970 # Root directory where all Java VMs/SDK/JREs expose their jars
971 %_jvmjardir             %{_libdir}/jvm-exports
972
973 # Root directory for all Java VM/SDK/JRE's private things.
974 %_jvmprivdir    %{_libdir}/jvm-private
975
976 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
977 %_jvmlibdir             %{_libdir}/jvm
978
979 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
980 %_jvmdatadir    %{_datadir}/jvm
981
982 # Root directory for all configurations parts of Java VM/SDK/JRE's
983 %_jvmsysconfdir %{_sysconfdir}/jvm
984
985 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
986 %_jvmcommonlibdir       %{_libdir}/jvm-common
987
988 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
989 %_jvmcommondatadir      %{_datadir}/jvm-common
990
991 # Root directory for all common configurations parts of Java VM/SDK/JRE's
992 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
993
994 # Directory where arch-specific (JNI) version-independent jars are installed.
995 %_jnidir                %{_libdir}/java
996
997
998 %java_home              %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})
999
1000 %ant                    JAVA_HOME=%{java_home} ant
1001 %jar                    %{java_home}/bin/jar
1002 %java                   %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
1003 %javac                  %{java_home}/bin/javac
1004 %javadoc                %{java_home}/bin/javadoc
1005
1006 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
1007
1008 %jpackage_script() \
1009 install -d $RPM_BUILD_ROOT%{_bindir}\
1010 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1011 #!/bin/sh\
1012 #\
1013 # %{name} script\
1014 # JPackage Project <http://www.jpackage.org/>\
1015 \
1016 # Source functions library\
1017 . %{_javadir}-utils/java-functions\
1018 \
1019 # Source system prefs\
1020 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1021     . %{_sysconfdir}/java/%{name}.conf\
1022 fi\
1023 \
1024 # Source user prefs\
1025 if [ -f $HOME/.%{name}rc ]; then\
1026     . $HOME/.%{name}rc\
1027 fi\
1028 \
1029 # Configuration\
1030 MAIN_CLASS=%1\
1031 BASE_FLAGS=%2\
1032 BASE_OPTIONS=%3\
1033 BASE_JARS="%(echo %4 | tr ':' ' ')"\
1034 \
1035 # Set parameters\
1036 set_jvm\
1037 set_classpath $BASE_JARS\
1038 set_flags $BASE_FLAGS\
1039 set_options $BASE_OPTIONS\
1040 \
1041 # Let's start\
1042 run "$@"\
1043 EOF
1044
1045 # PEAR install macros
1046 # Author: Elan Ruusamäe <glen@pld-linux.org>
1047 #
1048 # Usage:
1049 #       %%pear_package_setup [-a #] [-n FMT]
1050 #
1051 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1052 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1053 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1054 #
1055 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1056 # destination hierarchy. you should copy the tree to buildroot after
1057 # patching/reorganizing with %%pear_package_install.
1058 #
1059 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1060 # line endings.
1061 #
1062 # the pear install process output is recorded to install.log, you should put it
1063 # to %%doc for later debug or just for information.
1064 #
1065 # additionally additional-packages.txt is produced if it was detected that the
1066 # package has optional dependencies. the file format is suitable of displaying
1067 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1068 # automatically added for this file.
1069
1070
1071 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1072 %__pear_install_log \
1073 tee install.log \
1074 # make post message of optional packages \
1075 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1076 if [ -s optional-packages.txt ]; then \
1077         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1078 else \
1079         rm -f optional-packages.txt \
1080 fi \
1081 %{nil}
1082
1083 # command invoking pear cli
1084 %__pear /usr/bin/pear
1085
1086 # The main macro.
1087 # using this macro will append optional-packages.txt to the nocompressdoc list
1088 # as it's displayed to user after package install. and adding additional gzip
1089 # dep is just waste ;)
1090 %pear_package_setup(a:n:zD) \
1091 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1092 %define builddir %{_builddir}/%{srcdir} \
1093 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1094 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1095 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1096 %__pear \\\
1097         -c pearrc \\\
1098         -d doc_dir=/docs \\\
1099         -d php_dir=%{php_pear_dir} \\\
1100         -d bin_dir=%{_bindir} \\\
1101         -d data_dir=%{php_pear_dir}/data \\\
1102         -d test_dir=%{php_pear_dir}/tests \\\
1103         install \\\
1104         --packagingroot=%{builddir} \\\
1105         --offline \\\
1106         --nodeps \\\
1107         %{-f:--force} \\\
1108         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; } \
1109 %{-z:cd ..} \
1110 cat %{-z:$_N/}.install.log | %__pear_install_log \
1111 \
1112 # undos sources \
1113 find . -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1114 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1115 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1116 %{nil}
1117
1118 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1119 # Author: Elan Ruusamäe <glen@pld-linux.org>
1120 %pear_package_install() \
1121 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1122 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1123 # help the developer out a little: \
1124 if [ -f _noautoreq ]; then \
1125         echo "AutoReqdep detected:" \
1126         echo "_noautoreq $(cat _noautoreq)" \
1127 fi \
1128 %{nil}
1129
1130
1131 # Register OpenLDAP schema.
1132 # Author: Elan Ruusamäe <glen@pld-linux.org>
1133 #
1134 # Usage:
1135 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1136 #
1137 #  -d specify dependant schemas, separated by comma
1138 #
1139 %openldap_schema_register(d:) \
1140 for schema in %*; do \
1141         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1142                 %{__sed} -i -e " \
1143                         /^include.*local.schema/{ \
1144                                 iinclude\\t     $schema\
1145                         } \
1146                 " /etc/openldap/slapd.conf \
1147         fi \
1148 done \
1149 # enable dependant schemas \
1150 if [ "%{-d*}" ]; then \
1151         %{__sed} -i -e ' \
1152         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1153                 s/^#// \
1154         }' /etc/openldap/slapd.conf \
1155 fi \
1156 %{nil}
1157
1158 # Unregister OpenLDAP schema.
1159 # Author: Elan Ruusamäe <glen@pld-linux.org>
1160 #
1161 # Usage:
1162 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1163 #
1164 %openldap_schema_unregister() \
1165 for schema in %*; do \
1166         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1167                 %{__sed} -i -e " \
1168                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1169                 # for symmetry it would be nice if we disable enabled schemas in post, \
1170                 # but we really can not do that, it would break something else. \
1171                 " /etc/openldap/slapd.conf \
1172         fi \
1173 done \
1174 %{nil}
1175
1176 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1177
1178
1179 # Build modules for kernels 2.6
1180 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1181 #
1182 # Usage:
1183 #       %build_kernel_modules -m <modules> -C <directory>
1184 #
1185 #  remember that proper Makefile is still required
1186 # Options:
1187 #  -m <modules> (required) -- comma-separated list of modules to save,
1188 #               without .ko extension, may be placed in subdirectory
1189 #  -C <directory> -- change to <directory> before doing anything
1190 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1191 #  -c -- do not execute make clean
1192 #  <additional arguments> -- all additional arguments will be passed to
1193 #               make modules
1194 #
1195 # Additional patching supported via here document. Try:
1196 #       %build_kernel_modules -m module <<'EOF'
1197 #       your patch script here
1198 #       EOF
1199 # Don't use it unless patching depends on config options.
1200
1201 # Developer note: don't touch it unless you know how to handle '\'.
1202 # - \ in script expands to nothing
1203 # - \\\ in script expands to \
1204 # - \\\ inside definition expands to nothing
1205 # - \\\\\\\ inside definition expands to \
1206 # - in last line \ has to touch arguments so arguments passing
1207 #   in new lines (using \) will be supported
1208
1209 %build_kernel_modules(p:P:m:C:c)                                                                        \
1210 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1211                                                                                                                                         \
1212 %define Opts                                                                                                            \\\\\\\
1213 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1214         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1215         CC="%{__cc}" CPP="%{__cpp}" ARCH=%{_target_base_arch}                   \\\
1216         %else                                                                                                                   \\\
1217         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1218         %endif                                                                                                                  \\\
1219 %else                                                                                                                           \\\
1220         CC="%{__cc}" CPP="%{__cpp}"                                                                             \\\
1221 %endif                                                                                                                          \
1222 %define MakeOpts HOSTCC="%{__cc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1223                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1224                                                                                                                                         \
1225 %{?-C:cd %{-C*}}                                                                                                        \
1226 compile() {                                                                                                                     \
1227         L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"    \
1228         set -e -x                                                                                                               \
1229                                                                                                                                         \
1230 for cfg in %{?with_dist_kernel:dist}%{!?with_dist_kernel:nondist}; do \
1231         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1232                                                                                                                                         \
1233         rm -rf o                                                                                                                \
1234         install -d o/include/linux                                                                              \
1235         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1236         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1237         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1238 %ifarch ppc ppc64                                                                                                       \
1239         install -d o/include/asm                                                                                \
1240         [ ! -d %{_kernelsrcdir}/include/asm-%{_target_base_arch} ] || ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch}/* o/include/asm \
1241         [ ! -d %{_kernelsrcdir}/include/asm-powerpc ] || ln -snf %{_kernelsrcdir}/include/asm-powerpc/* o/include/asm   \
1242 %else                                                                                                                           \
1243         ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch} o/include/asm \
1244 %endif                                                                                                                          \
1245                                                                                                                                         \
1246         set +x                                                                                                                  \
1247         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1248         set -x                                                                                                                  \
1249                                                                                                                                         \
1250         %if %{with dist_kernel}                                                                                 \
1251                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1252                         %{-p*} %{-P*}                                                                                   \\\
1253                         %{MakeOpts}                                                                                             \
1254         %else                                                                                                                   \
1255                 install -d o/include/config                                                                     \
1256                 touch o/include/config/MARKER                                                           \
1257                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1258         %endif                                                                                                                  \
1259                                                                                                                                         \
1260         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1261                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1262                 M=$PWD %{MakeOpts}}                                                                                     \
1263         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1264                 ${1+"$@"}                                                                                                       \\\
1265                 M=$PWD %{MakeOpts}                                                                                      \
1266                                                                                                                                         \
1267         for MODULE in {%{-m*},}; do                                                                             \
1268                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1269         done                                                                                                                    \
1270 done                                                                                                                            \
1271 %{?-C:cd -}                                                                                                                     \
1272 }                                                                                                                                       \
1273 compile %{*}\
1274 %{nil}
1275
1276
1277 # Install kernel modules built by %build_kernel_modules
1278 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1279 #
1280 # Usage:
1281 #       %install_kernel_modules -m <modules> -d <directory>
1282 #
1283 # Options:
1284 #  -m <modules> (required) -- comma-separated list of modules to install,
1285 #               without .ko extension, may be placed in subdirectory
1286 #  -d <directory> (required) -- in what subdirectory modules should be
1287 #               installed (eg. misc, kernel/drivers/net)
1288 #  -s <suffix> -- suffix to use when installing modules, useful when module
1289 #               with same name exists in kernel already
1290 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1291 #               for definig aliases, only useful with -s
1292
1293 %install_kernel_modules(m:d:s:n:)                                                                       \
1294 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1295 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1296 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1297                                                                                                                                         \
1298 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1299 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1300                                                                                                                                         \
1301 install -d %{KernelD}/%{-d*}                                                                    \
1302 %{?-s:install -d %{ModprobeD}}                                                          \
1303                                                                                                                                         \
1304 for MODULE in {%{-m*},}; do                                                                                     \
1305         [ -n "${MODULE}" ] || continue                                                                  \
1306         MNAME=${MODULE##*/}                                                                                             \
1307         %if %{without dist_kernel}                                                                              \
1308                 install ${MODULE}-nondist.ko                                                            \\\
1309                         %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                              \
1310                 %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                     \\\
1311                         >> %{ModprobeD}/%{-n*}.conf}                                                    \
1312         %else                                                                                                                   \
1313                 install ${MODULE}-dist.ko                                                                               \\\
1314                         %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                              \
1315                 %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                     \\\
1316                         >> %{ModprobeD}/%{-n*}.conf}                                                    \
1317         %endif                                                                                                                  \
1318 done                                                                                                                            \
1319 %{nil}
1320
1321 # patchset macros
1322 # Author: Elan Ruusamäe <glen@pld-linux.org>
1323 #
1324 # Usage:
1325 #   %patchset_source -f <seq(1) format> <start> [<end>]
1326 #   %patchset_patch <start> [<end>]
1327 #
1328 # If <end> is omited, it is assumed to be <start>.
1329 #
1330 # For example in preamble:
1331 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1332 # and in %prep:
1333 #  %patchset_patch 33 44
1334
1335 # generate SourceX urls from range START STOP
1336 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1337 # The sources start from 10000
1338 %patchset_source(f:b:) %(
1339         base=%{-b*}%{!-b*:10000};
1340         start=$(expr $base + %1);
1341         end=$(expr $base + %{?2}%{!?2:%{1}});
1342         # we need to call seq twice as it doesn't allow two formats
1343         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1344         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1345         paste %{tmpdir}/__ps{1,2};
1346         rm -f %{tmpdir}/__ps{1,2};
1347 ) \
1348 %{nil}
1349
1350 # apply sources from %patchset_source
1351 # -p specify -pX for %patch line
1352 # -b base offset: defaults to 10000
1353 %patchset_patch(f:p:b:) %(
1354         base=%{-b*}%{!-b*:10000};
1355         start=$(expr $base + %1);
1356         end=$(expr $base + %{?2}%{!?2:%{1}});
1357         echo ": patchset_patch %1%{?2: to %2}";
1358         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1359 ) \
1360 %{nil}
1361
1362 # browser plugins v2
1363 # Author: Elan Ruusamäe <glen@pld-linux.org>
1364 #
1365 # Usage:
1366 #       %browser_plugins_add_browser <name> -p <plugindir>
1367 #
1368 #  <name> (required) -- name of the browser. usually %{name}.
1369 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1370 #  -b -- default blacklists
1371 #  -a <arch> override arch
1372 #
1373 # Example:
1374 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1375
1376 %_browserpluginsconfdir         /etc/browser-plugins
1377 %_browserpluginsdir                     %{_libdir}/browser-plugins
1378 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1379
1380 %browser_plugins_add_browser(p:b:a:) \
1381         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1382         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1383         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1384         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1385         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1386         %{-b:cat >> $blacklist_file %{-b*}} \
1387 %{nil}
1388
1389 # vim:ts=4 sw=4 noet syn=spec
This page took 0.168088 seconds and 3 git commands to generate.